/* Exemplo 4 - Aqui pretende-se um programa que lance um outro e espere um certo tempo para que o 2o termine. */
/* Caso isso  não aconteça deverá terminá-lo de modo forçado. */
/* Exemplo de linha de comando: */
/* limit n prog arg1 arg2 arg3 	*/
/* n - no de segundos a esperar */
/* prog - programa a executar   */
/* arg1, arg2, ..., argn - argumentos de prog */

#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>

int delay;
void childhandler(int signo);

void main(int argc, char *argv[]) {
	pid_t pid;
	
	signal(SIGCHLD, childhandler); /* quando um processo filho terminar envie ao pai o sinal SIGCHLD */
	pid = fork();
	if (pid = 0)
		execvp(argv[2], &argv[2]);
	else {
		sscanf(argv[1], "%d", &delay); /* transforma string em valor */
		sleep(delay);
		printf("Program %s exceeded limit of %d seconds!\n", argv[2], delay);
		kill(pid, SIGKILL);
	}
}

void childhandler(int signo) {
	int status;
	pid_t pid;

	pid = wait(&status);
	printf("Child %d terminated within %d seconds.\n", pid, delay);
	exit(0);
}



