/* Estabelecimento de um alarme e respectivo handler */

#include <stdio.h>
#include <signal.h>

int alarmflag = 0;			/* Global fire alarm */
void alarmhandler(int signo); 		/* Forward declaration of alarm handler */

void main(void) {
	signal(SIGALRM, alarmhandler);	/* Install signal handler */
	alarm(5);			/* Schedule an alarm signal in three seconds */
	printf("Looping ...\n");
	while (!alarmflag) {		/* Loop until flag set */
		pause();		/* Wait for a signal */
	}
	printf("Ending ...\n");
}

void alarmhandler(int signo) { 
	printf("Alarm received ...\n");
	alarmflag = 1;
}


